/*//////////////////////////////////////////////////////////////////////////////
// Licensed Materials - Use restricted. For use in compiling interfaces to
// IBM Rational TestManager.
// (c) Copyright IBM Corporation 2006.  All Rights Reserved.
//
//	FILENAME:		psystem.h
//	DESCRIPTION:	defines for virtual user proxies of Win 32 functions
//
//	REVISION HISTORY
//	PROGRAMMER		DATE		REVISION
//	============================================================================
//
//  TDA             11/30/98 REMOVE WINSOCK* defines
//  PXZ             11/24/98 add GETHOSTBYNAME
//  PXZ             11/19/98 add api id for winsock1
//	DJM				11/6/98	initial product version
//
////////////////////////////////////////////////////////////////////////////////
*/


#ifndef __INCLUDE_PSYSTEM_H
#define __INCLUDE_PSYSTEM_H	

/* 
add new defines as desired, WARNING
changing existing defines would make old
watch files incompatible 

Use PROXY_LIB_WINDOWS_SYSTEM with these individual API identifiers

the defines are to be used in calls to ProxyLock() in sqaputil dll
in recording the API data	


the following defines are quasi-proxies in sqaputil.dll
they write a record of process and thread ID's as they
are created when the DLL is notified in DllMain()
*/
#define P_PROCESS_ATTACH		1
#define P_PROCESS_DETACH		2
#define P_THREAD_ATTACH			3
#define P_THREAD_DETACH			4
/* now, the real proxy ID's */
#define P_CREATE_PROCESS_A		5
#define P_CREATE_PROCESS_W		6
#define P_CREATE_THREAD			7
#define P_WINEXEC			8
#define P_CUSTOMADAPTER_A		9 
#define P_CUSTOMADAPTER_W		10
#define P_COMADAPTER_A			11 
#define P_COMADAPTER_W			12

/* if more funcs are added, modify this count */
#define P_SYSTEM_API_COUNT	12



/*
 do type defing of any structures for system proxies here
 e.g.; typedef CreateProcess{ ................
*/

typedef struct{
	HANDLE	hReturn;
	DWORD	dwThreadId;
}S_CREATE_THREAD;

typedef struct{
	BOOL	bReturn;
	BOOL	bInheritHandles;
	DWORD	dwCreationFlags;
	DWORD	dwProcessId;
	DWORD	dwThreadId;
	int		iOffszApplicationName;
	int		iOffszCommandLine;
	int		iOffszCurrentDirectory;
	int		iOffEnvironmentStrings;
}S_CREATE_PROCESS;

/* for P_CUSTOMADAPTER_A, the strings will be ASCII
// for P_CUSTOMADAPTER_W. the strings will be UNICODE
*/

typedef struct{
	unsigned int	uiLibID;
	int	iOffszLibraryName; /* name of recorder DLL */
	int	iOffszTargetName; /* name of Target DLL */
	int	iOffszProtocol; /* name of the protocol being recorded */
	int	iOffszDescription; /* Optional customer supplied description string */
	int	iOffszVersion;  /* Optional customer supplied version string */
	int	iOffszReserved;  /* Reserved for future use */
}S_CUSTOMADAPTER;

typedef struct{
	unsigned int	uiLibID;
	int	iOffszLibraryName; 	/* name of recorder DLL */
	int	iOffszTypelibs; 	/* Typelibs defining scope of COM object hooking */
	int	iOffszProtocol; 	/* name of the protocol being recorded */
	int	iOffszDescription; 	/* Optional customer supplied description string */
	int	iOffszVersion;  	/* Optional customer supplied version string */
	int	iOffszReserved;  	/* Reserved for future use */
}S_COMADAPTER;

#endif /*__INCLUDE_PSYSTEM_H */
